/*******************************************************************************
*									       *
* [PSXg[ANZXvOC]					       *
*									       *
*	FILE NAME	: PSRP.h 					       *
*									       *
*	History		| Comment				Name	       *
*     ------------------+--------------------------------------------------    *
*	2000.01.22	| VK쐬				ӂ	       *
*	2000.05.01	| CDT|[ĝߑSʏC		ӂ	       *
*	2000.09.27	| Đ̋I΍			Ribot	       *
*	2000.10.28	| PSRSTREAMINFOPSRPLUGIN̕ύX	ӂ	       *
*									       *
*				(C) Copyright ӂ 2000. All rights reserved.*
*******************************************************************************/


#ifndef PSXMC_PSRPLUGIN
#define PSXMC_PSRPLUGIN


#ifndef CEXPORT
#define CEXPORT	extern __declspec (dllexport)
#endif

#define PSR_FRAMEBUFFER		0xb000					//000927


/******************************************************************************/
/*									      */
/*	\``							      */
/*									      */
/******************************************************************************/

typedef struct {	// Xg[f[^ --------------------------------
	WORD		wTypeFlags;	// f[^ʃtO	PSR_STRTYPE_XXX
	WORD		wReserved;	// \	0Œ
	DWORD		nBeginSector;	// f[^JnZN^ԍ
	DWORD		nNumSector;	// f[^ZN^
	DWORD		nPlayTime;	// Đ	1/1000bP
	DWORD		nNumFrame;	// t[
	SIZE		szFrame;	// t[TCY
	WORD		wFrameRate;	// t[[g
	WORD		wFormatTag;	// f[^̃tH[}bg
	WORD		wChannels;	// m/XeI̕
	WORD		wBitsPerSample;	// Tṽrbg
	DWORD		nSamplesPerSec;	// TvO[g
	DWORD		nDataSize;	// f[^TCY(byte)	0
} PSRSTREAMINFO, *LPPSRSTREAMINFO;


			// f[^ʃtO ------------------------------------
#define PSR_STRTYPE_MOVIE	0x0001	// Xg[
#define PSR_STRTYPE_AUDIO	0x0002	// Xg[
#define PSR_STRTYPE_ALL		0x0003	// Xg[ & Xg[

#define PSR_STRTYPE_VFRATE	0x0010	// σt[[g


typedef struct {	// ǂݍ݃obt@ ------------------------------------
	DWORD		nFrameNo;	// t[ԍ
	SIZE		szFrame;	// t[TCY
	WORD		wFrameRate;	// t[[g	0:Œڰڰ
	WORD		wReserved;	// 0Œ
	DWORD		nLength;	// f[^
	BYTE		abData[PSR_FRAMEBUFFER]; // f[^
} PSRREADBUFF, *LPPSRREADBUFF;




/******************************************************************************/
/*									      */
/* PsrQueryPlugin() : vOC̎擾 ( : K{)		      */
/*									      */
/*	vOCʂ閼OȂǂ̏Ԃ܂B			      */
/*									      */
/******************************************************************************/


#define PSR_MAX_PLUGINNAME	48	// vOCʖ
#define PSR_MAX_COPYRIGHT	80	// Rs[Cg
#define PSR_MAX_SITENAME	80	// TCg
#define PSR_MAX_SITEURL		80	// TCgURL

#define PSR_SYSTEMVERSION220	220	// ΉVXeo[W	2.20
#define PSR_SYSTEMVERSION	230	// ΉVXeo[W	2.30

typedef struct {	// vOC --------------------------------------
	CHAR		aName[PSR_MAX_PLUGINNAME+1];	// vOCʖ
	CHAR		aCopyright[PSR_MAX_COPYRIGHT+1];// Rs[Cg
	USHORT		usVersion;		// o[Wԍ
	USHORT		usIsSupportVersion;	// 茋ʕۏ؃o[W
	USHORT		usSystemVersion;	// ΉVXeo[W
	CHAR		aSiteName[PSR_MAX_SITENAME+1];	// TCg	ȗ
	CHAR		aSiteUrl[PSR_MAX_SITEURL+1];	// TCg URL	ȗ
} PSRPLUGIN, *LPPSRPLUGIN;


CEXPORT	VOID	PsrQueryPlugin(
	LPPSRPLUGIN	lpPlugin);	// vOC擾obt@AhX

typedef VOID	(*PFNPSRQUERYP)(LPPSRPLUGIN);



/******************************************************************************/
/*									      */
/* PsrIsSupportFile() : Xg[t@C̃T|[g (FILE : K{)	      */
/*									      */
/*	wt@CYvOCŃT|[gł`̃Xg[f[^  */
/*	邩𔻒肵܂B						      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrIsSupportFile(
	LPCTSTR		lpFileName);	// t@C

typedef BOOL	(*PFNPSRISSF)(LPCTSTR);




/******************************************************************************/
/*									      */
/* PsrIsSupportCDBegin() : CDT|[g Jn (CD : K{)		      */
/*									      */
/*	CDYvOCŃT|[gł`̃Xg[f[^܂ł  */
/*	𔻒肷邽߂̊Jns܂B				      */
/*									      */
/******************************************************************************/

#ifdef PSXMC_CDACCESS
CEXPORT HANDLE	PsrIsSupportCDBegin(
	INT		iNumToc,	// TOC̐
	LPTOCENTRY	lptoc);		// TOC

typedef HANDLE	(*PFNPSRISSCDB)(INT, LPTOCENTRY);



/******************************************************************************/
/*									      */
/* PsrIsSupportCDEnd() : CDT|[g I (CD : K{)		      */
/*									      */
/*	CDYvOCŃT|[gł`̃Xg[f[^܂ł  */
/*	𔻒肷邽߂̏Is܂B				      */
/*									      */
/******************************************************************************/

CEXPORT	VOID	PsrIsSupportCDEnd(
	HANDLE		hIsCD);		// CDT|[gnh

typedef VOID	(*PFNPSRISSCDE)(HANDLE);



/******************************************************************************/
/*									      */
/* PsrIsSupportCDSector() : CDT|[g ZN^ʒm (CD : K{)	      */
/*									      */
/*	CDYvOCŃT|[gł`̃Xg[f[^܂ł  */
/*	𔻒肷邽߂̏s܂B				      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrIsSupportCDSector(
	HANDLE		hIsCD,		// CDT|[gnh
	TOCENTRY	toc,		// TOC
	DWORD		nSector,	// ZN^ԍ
	PVOID		pvSector);	// ZN^

typedef BOOL	(*PFNPSRISSCDS)(HANDLE, TOCENTRY, DWORD, PVOID);



/******************************************************************************/
/*									      */
/* PsrIsSupportCDResult() : CDT|[g ʎ擾 (CD : K{)		      */
/*									      */
/*	CDYvOCŃT|[gł`̃Xg[f[^܂ł  */
/*	𔻒肵ʂԂ܂B					      */
/*									      */
/******************************************************************************/

CEXPORT	INT	PsrIsSupportCDResult(
	HANDLE		hIsCD,		// CDT|[gnh
	INT		iIndex,		// Xg[CfbNX
	LPPSRSTREAMINFO	lpStreamInfo);	// Xg[f[^

typedef INT	(*PFNPSRISSCDR)(HANDLE, INT, LPPSRSTREAMINFO);
#endif	// PSXMC_CDACCESS



/******************************************************************************/
/*									      */
/* PsrGetStrFileInfo() : Xg[t@C̎擾 (FILE : K{)	      */
/*									      */
/*	wt@C̃Xg[f[^ɊւԂ܂B		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrGetStrFileInfo(
	LPCTSTR		lpFileName,	// t@C
	LPPSRSTREAMINFO	lpStreamInfo);	// Xg[f[^

typedef BOOL	(*PFNPSRGETSFI)(LPCTSTR, LPPSRSTREAMINFO);



/******************************************************************************/
/*									      */
/* PsrGetStrDataInfo() : Xg[f[^̎擾 (CD : K{)		      */
/*									      */
/*	CD̎wXg[f[^ɊւԂ܂B		      */
/*									      */
/******************************************************************************/

CEXPORT	BOOL	PsrGetStrDataInfo(
	INT		iDriveNo,	// hCuԍ
	DWORD		dwBegin,	// JnZN^ԍ
	DWORD		dwNumSector,	// ZN^
	LPPSRSTREAMINFO	lpStreamInfo);	// Xg[f[^

typedef BOOL	(*PFNPSRGETSDI)(INT, DWORD, DWORD, LPPSRSTREAMINFO);



/******************************************************************************/
/*									      */
/* PsrOpenFile() : Xg[t@C̃I[v (FILE : K{)		      */
/*									      */
/*	wt@C̃Xg[f[^I[v܂B		      */
/*									      */
/******************************************************************************/

CEXPORT HANDLE	PsrOpenFile(
	LPCTSTR		lpFileName,	// t@C
	LPPSRSTREAMINFO	lpStreamInfo);	// Xg[f[^

typedef HANDLE	(*PFNPSROPENFILE)(LPCTSTR, LPPSRSTREAMINFO);



/******************************************************************************/
/*									      */
/* PsrOpenCD() : CDXg[̃I[v (CD : K{)			      */
/*									      */
/*	CD̎wXg[f[^I[v܂B			      */
/*									      */
/******************************************************************************/

#ifdef PSXMC_CDACCESS
CEXPORT HANDLE	PsrOpenCD(
	INT		iDriveNo,	// hCuԍ
	LPPSRSTREAMINFO	lpStreamInfo);	// Xg[f[^

typedef HANDLE	(*PFNPSROPENCD)(INT, LPPSRSTREAMINFO);
#endif	// PSXMC_CDACCESS



/******************************************************************************/
/*									      */
/* PsrClose() : Xg[f[^̃N[Y ( : K{)		      */
/*									      */
/*	PsrOpenFile()܂PsrOpenCD()ɂI[vXg[f[^    */
/*	N[Y܂B						      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrClose(
	HANDLE		hStream);	// Xg[nh

typedef BOOL	(*PFNPSRCLOSE)(HANDLE);


/******************************************************************************/
/*									      */
/* PsrRead() : Xg[f[^̓ǂݎ ( : K{)			      */
/*									      */
/*	Xg[f[^瓮f[^܂͉f[^ǂݎ܂B	      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrRead(
	HANDLE		hStream,	// Xg[nh
	LPPSRREADBUFF	lpBuffer);	// ǂݎobt@

typedef BOOL	(*PFNPSRREAD)(HANDLE, LPPSRREADBUFF);


/******************************************************************************/
/*									      */
/* PsrSeek() : ǂݎʒu̐ݒ ( : K{)				      */
/*									      */
/*	Xg[f[^̓ǂݎʒuw肳ꂽt[f[^̐擪Ɉړ*/
/*	܂B								      */
/*									      */
/******************************************************************************/

CEXPORT BOOL	PsrSeek(
	HANDLE		hStream,	// Xg[nh
	DWORD		dwPosition);	// ǂݎʒu		1/1000bP

typedef BOOL	(*PFNPSRSEEK)(HANDLE, DWORD);



/******************************************************************************/
/*									      */
/* PsrDecodeFrame() : f[^̃fR[h ()			      */
/*									      */
/*	ʏSTRt@CƂ͈قȂ铮f[^fR[h܂B		      */
/*									      */
/*	̃t@NVPsrDecodeBs֐ȗꂽꍇÃvOC */
/*	PsrRead()ǂݎf[^ʏSTRt@Č`łƔF*/
/*	܂B								      */
/*									      */
/******************************************************************************/

#define PSR_DECODE_ERROR	0xffffffff
#define PSR_DECODE_NORMAL	0

CEXPORT LPBITMAPINFO PsrDecodeFrame(
	LPPSRREADBUFF	lpFrame,	// t[f[^
	LPBITMAPINFO	lpbmi);		// DIBrbg}bv

typedef LPBITMAPINFO	(*PFNPSRDECODEF)(LPPSRREADBUFF, LPBITMAPINFO);


/******************************************************************************/
/*									      */
/* PsrDecodeBs() : BSfR[h ()					      */
/*									      */
/*	ʏSTRt@CƂ͈قȂ铮f[^fR[h܂B		      */
/*									      */
/*	̃t@NVPsrDecodeFrame֐ȗꂽꍇÃvOC*/
/*	PsrRead()ǂݎf[^ʏSTRt@Č`łƔF*/
/*	܂B							      */
/*									      */
/******************************************************************************/

CEXPORT	PUSHORT	PsrDecodeBs(
	LPPSRREADBUFF	lpFrame);	// t[f[^

typedef PUSHORT	(*PFNPSRDECODEB)(LPPSRREADBUFF);


/******************************************************************************/
/*									      */
/* PsrDecodeAudio() : f[^̃fR[h ()			      */
/*									      */
/*	ʏSTRt@CƂ͈قȂ鉹f[^fR[h܂B		      */
/*									      */
/*	̃t@NVȗꂽꍇÃvOCPsrRead()ǂ   */
/*	f[^ʏSTRt@Č`łƔF܂B	      */
/*									      */
/******************************************************************************/

CEXPORT DWORD	PsrDecodeAudio(
	LPPSRREADBUFF	lpAudio,	// f[^
	PVOID		pvBuffer,	// fR[h̉f[^
	DWORD		nLength);	// lpBuffer̃oCg

typedef DWORD	(*PFNPSRDECODEA)(LPPSRREADBUFF, PVOID, DWORD);


/******************************************************************************/
/*									      */
/* PsrSetEntrionment() : ݒpľĂяo ()		      */
/*									      */
/*	YvOCɕKvȊݒspl\܂B	      */
/*									      */
/*	̃t@NVȗꂽꍇÃvOCɊݒ̕Kv*/
/*	ƔF܂B						      */
/*									      */
/******************************************************************************/

CEXPORT VOID	PsrSetEnvironment(
	HWND		hWndParent);	// eEChE

typedef VOID	(*PFNPSRSETE)(HWND);
#endif
